CON

  CR = $0d
  LF = $0a
  CRLF = $0d0a                           

  DEFAULT_TERMINATOR = CRLF

VAR

  byte CurrentPathName[64]
  long CurrentTerminator

OBJ

  sdc   : "SD-MMC_FATEngine.spin"

PUB start

  \sdc.fatEngineStart(22, 23, 24, 25, -1, -1, -1, -1, -1)
  CurrentTerminator := DEFAULT_TERMINATOR

PUB openRead(pathName)

  \sdc.mountPartition(0)
  \sdc.openFile(pathName, "R")

PUB openWrite(pathName)

  \sdc.mountPartition(0)
  \sdc.deleteEntry(pathName)
  openAppend(pathName)

PUB openAppend(pathName)

  \sdc.mountPartition(0)
  \sdc.newFile(pathName)
  bytemove(@CurrentPathName, pathName, strsize(pathName) + 1)
  '\sdc.unmountPartition

PUB close

  \sdc.closeFile
  \sdc.unmountPartition

PUB readLine(lineAddr) | char

  repeat
    char := byte[lineAddr++] := \sdc.readByte
  until (char == CurrentTerminator & $ff or char == 0)
  byte[lineAddr - 1]~

PUB readCsvLongs(longArrayAddr, count)

  repeat
      

PUB writeLine(lineAddr)

  startLine
  \sdc.writeString(lineAddr)
  endLine

PUB writeCsvLine(longArrayAddr, formatArray) | i, count, fmt

  startLine
  count := strsize(formatArray)
  repeat i from 0 to count - 1
    fmt := byte[formatArray][i]
    if (fmt == "S")
      writeStr(long[longArrayAddr][i])
    elseif (fmt == "Q")
      writeByte(34)
      writeStr(long[longArrayAddr][i])
      writeByte(34)
    else
      writeDec(long[longArrayAddr][i], (fmt - "0") #> 0 <# 9)
    if (i < count - 1)
      \sdc.writeByte(",")
  endLine

PUB startLine

  \sdc.mountPartition(0)
  \sdc.openFile(@CurrentPathName, "A")

PUB writeDec(value, places) | i, x, j

  x := value == NEGX                                    'Check for max negative
  if value < 0
    value := ||(value+x)                                'If negative, make positive; adjust for max negative
    \sdc.writeByte("-")                                  'and output sign

  i := 1_000_000_000                                    'Initialize divisor

  repeat j from 10 to 1                                  'Loop for 10 digits
    if (places == j)
      \sdc.writeByte(".")                                
    if value => i                                                               
      \sdc.writeByte(value / i + "0" + x*(i == 1))      'If non-zero digit, output digit; adjust for max negative
      value //= i                                       'and digit from value
      result~~                                          'flag non-zero found
    elseif result or j =< places + 1
      \sdc.writeByte("0")                               'If zero digit (or only digit) output it
    i /= 10                                             'Update divisor

PUB writeByte(value)

  startLine
  \sdc.writeByte(value)
  \sdc.closeFile

PUB writeStr(strAddr)

  startLine
  \sdc.writeString(strAddr)
  \sdc.closeFile
  
PUB endLine

  repeat 4
    CurrentTerminator <-= 8
    if (CurrentTerminator & $ff)
      \sdc.writeByte(CurrentTerminator)
  \sdc.closeFile
  '\sdc.unmountPartition

PUB setTerminator(terminator)

  CurrentTerminator := terminator  